Magellan Linux

Diff of /tags/installer-simple-0_4_90_20140703_1/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2344 by niro, Fri Jan 3 15:01:06 2014 UTC revision 2653 by niro, Thu Jul 3 08:01:05 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  # ignore the environment  # setup locales
11  LC_ALL=C  TEXTDOMAIN=installer
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
15    
# Line 16  INSTALLER_LIBDIR="%LIBDIR%" Line 17  INSTALLER_LIBDIR="%LIBDIR%"
17  # -> now in images.conf  # -> now in images.conf
18  CURRENTLINE=0  CURRENTLINE=0
19    
20  # configuration  die()
21  if [ -e %SYSCONFDIR%/installer.conf ]  {
22  then   echo "Error: $@"
23   source %SYSCONFDIR%/installer.conf   exit 1
24  else  }
  die "/etc/installer.conf not found"  
 fi  
   
 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  
 # -> now in images.conf  
 CDIMAGENAME=""  
 TOTALLINES=""  
 CURRENTLINE=0  
 if [ -e /mnt/cdrom/system/images.conf ]  
 then  
  source /mnt/cdrom/system/images.conf  
  # check if all required variables are set  
  [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"  
  [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"  
 else  
  die "/mnt/cdrom/system/images.conf not found"  
 fi  
25    
26  # includes  # load common includes
27  source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  for inc in %SYSCONFDIR%/installer.conf \
28     ${INSTALLER_LIBDIR}/functions/common.sh \
29     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
30     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
31     ${INSTALLER_LIBDIR}/functions/bootloader.sh \
32     ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
33     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
34    do
35     if [ -e ${inc} ]
36     then
37     source "${inc}"
38     else
39     die "'${inc}' not found"
40     fi
41    done
42    
43  ### System/Config Version  ### System/Config Version
44  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
45  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
46    
47  CDROOT="${DEFAULT_CDROOT}"  # some sane defaults
48    LIVEROOT="${DEFAULT_LIVEROOT}"
49    IMAGEROOT="${DEFAULT_IMAGEROOT}"
50  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
51    KERNELPKG="${DEFAULT_KERNELPKG}"
52  # standard kernel opts  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
53  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
54  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
55  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
56  SPECIALDEVICE=""  SPECIALDEVICE=""
57  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
58  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
59    
60  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
61  #  DIALOG BOXEN #  # -> now in images.conf
62  #################################################  CDIMAGENAME=""
63    TOTALLINES=""
64  die()  CURRENTLINE=0
65  {  if [ -e ${IMAGEROOT}/images.conf ]
66   echo "Error: $@"  then
67   exit 1   source ${IMAGEROOT}/images.conf
68  }   # check if all required variables are set
69     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
70  dialog_die()   [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
71  {  else
72   ERROR="$1"   die "${IMAGEROOT}/images.conf not found"
73   RETVAL="$?"  fi
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --defaultno \  
  --yesno "\Z1 !!! Achtung !!! \Zn\n\n\  
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
  then  
  clear  
  echo "Der Vorgang wurde abgebrochen."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_auto()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
 }  
   
 dialog_setup_system_menu()  
 {  
  local i  
   
  i=$(dialog \  
  --backtitle "${TITLE}" \  
  --title "[ Festplatten Partitionierung ]" \  
  --cancel-label "Abbrechen" \  
  --ok-label "Weiter" \  
  --stdout \  
  --colors \  
  --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \  
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  case "${i}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "3") run_install_flash ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local i  
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
   
  run_hardware_detection_disks  
   
  echo "dialog \\"  > ${hwtmp}  
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  done  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " CDROM Laufwerke:\n \\" >> ${hwtmp}  
  for i in ${ALL_CDROMS}  
  do  
  echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  done  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}  
  fi  
   
  echo " \" 14 70" >> ${hwtmp}  
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manuell  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_auto()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
  fi  
 }  
   
 run_hardware_detection_disks()  
 {  
  local bootdev  
   
  # all disks but exclude ramdisks  
  export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')  
  # remove the boot device from ALL_DISKS if it was an usbstick  
  if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]  
  then  
  bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"  
  export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")  
  fi  
  export ALL_CDROMS="$(get_hwinfo cdrom)"  
 }  
   
 dialog_setup_hdd_create_partitions()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
74    
75  dialog_setup_hdd_format()  ### helper scripts ###
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
76    
77  dialog_install_settings()  trap_exit()
78  {  {
79   dialog \   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
80   --backtitle "${TITLE}" \   is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
81   --infobox "Speichere System-Einstellungen ..." 3 70   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
82  }   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
83     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
84    
85  dialog_install_system_image()   echo $"Installation aborted."
86  {   exit 1
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
87  }  }
88    
89  dialog_install_meter()  install_meter()
90  {  {
91   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
92   do   do
# Line 410  dialog_install_meter() Line 99  dialog_install_meter()
99   return 0   return 0
100  }  }
101    
102    mount_rootfs()
 dialog_install_bootsector()  
103  {  {
104   dialog \   local retval
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
105    
106  dialog_install_successful()   if is_mounted --location "${INSTALLROOT}"
107  {   then
108   dialog \   echo $"${INSTALLROOT} already mounted" >&2
109   --backtitle "${TITLE}" \   else
110   --colors \   mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
111   --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81   fi
112     [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
113  }  }
114    
115  dialog_install_failure()  umount_rootfs()
116  {  {
117   dialog \   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
118   --backtitle "${TITLE}" \   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
119  }  }
120    
121  dialog_main()  install_do_reboot()
122  {  {
123   METHOD=0   reboot
   
  while [[ ${METHOD} -le 2 ]]  
  do  
  METHOD=$(dialog \  
  --backtitle "${TITLE}" \  
  --no-cancel \  
  --ok-label "Weiter" \  
  --stdout \  
  --menu "Konfiguration" 14 70 5 \  
  "1" "AutoSta_LX installieren" \  
  "2" "Uebersicht gefundener Laufwerke" \  
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  case ${METHOD} in  
  "1") dialog_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
124  }  }
125    
 #################################################  
 # Install Komandos #  
 #################################################  
126  run_hardware_detection()  run_hardware_detection()
127  {  {
128   local hwinfo   local hwinfo
129    
130   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
131    
132   # check for special devices/clients:   ## check for special devices/clients:
133   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
134   local removable=0   #local removable=0
135   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
136   then   #then
137   for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
138   do   #do
139   if [[ $(< ${i}) = 1 ]]   #if [[ $(< ${i}) = 1 ]]
140   then   #then
141   removable=1   #removable=1
142   fi   #fi
143   done   #done
144     ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
145   # only add this for grub legacy, grub2 detect these settings on its own  
146   export GRUBLEGACYOPTS="rootdelay=8"   ## only add this for grub legacy, grub2 detect these settings on its own
147   # there are to zotac types in the wild, nvidia based gfx and intel   #export GRUBLEGACYOPTS="rootdelay=8"
148   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   ## there are to zotac types in the wild, nvidia based gfx and intel
149   then   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
150   export SPECIALDEVICE="zotac_nvidia"   #then
151   else   #export SPECIALDEVICE="zotac_nvidia"
152   export SPECIALDEVICE="zotac_intel"   #else
153   fi   #export SPECIALDEVICE="zotac_intel"
154   fi   #fi
155     #fi
156    
157   # check for special devices/clients:   # check for special devices/clients:
158   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 526  run_hardware_detection() Line 181  run_hardware_detection()
181   fi   fi
182  }  }
183    
184  hdd_size_below_256mb()  run_hardware_detection_disks()
185  {  {
186   local hdd="$1"   local bootdev
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
187    
188   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   # all disks but exclude ramdisks
189   if [[ ${size} -le 257000000 ]]   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
190     # remove the boot device from ALL_DISKS if it was an usbstick
191     if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
192   then   then
193   retval="0"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
194   else   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  retval="1"  
195   fi   fi
196     export ALL_CDROMS="$(get_hwinfo cdrom)"
  return "${retval}"  
197  }  }
198    
199  setup_hdd_partitions_auto()  setup_hdd_partitions_auto()
200  {  {
201   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
202    
203     # sanity check - should not happen
204     if is_mounted --device "${ROOTHDD}"
205     then
206     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
207     umount "${ROOTHDD}"
208     fi
209    
210   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
211   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
212   then   then
213   if hdd_size_below_256mb ${HDD}   if device_minimum_size "${HDD}" 256
214   then   then
215   FDISKPARTIONBELOW256MB=1   FDISKPARTIONBELOW256MB=1
216   else   else
# Line 606  EOF Line 265  EOF
265   fi   fi
266  }  }
267    
268  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
269  {  {
270   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
271     SWAPHDD=""
272   ## hdds partitionieren manuell   BOOTHDD=""
273   cfdisk ${HDD} || dialog_die   cfdisk ${HDD} || dialog_die
274  }  }
275    
276  setup_hdd_format()  setup_hdd_format()
277  {  {
278   mkswap ${SWAPHDD} || dialog_die   # sanity check - should not happen
279   mke2fs -j -q ${BOOTHDD} || dialog_die   if is_mounted --device "${ROOTHDD}"
280   mke2fs -j -q ${ROOTHDD} || dialog_die   then
281  }   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
282     umount "${ROOTHDD}"
283  setup_hdd_format_flash()   fi
 {  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
 }  
   
 install_mount_rootfs()  
 {  
  swapon ${SWAPHDD} || dialog_die  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  mount ${BOOTHDD} ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
 }  
284    
285  install_mount_rootfs_flash()   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
 {  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
286  }  }
287    
288  install_system_image()  install_system_image()
289  {  {
290   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   pushd ${INSTALLROOT} > /dev/null
291     tar xvjpf ${IMAGEROOT}}/${CDIMAGENAME} -C ${INSTALLROOT}
292     popd > /dev/null
293  }  }
294    
295  install_bootsector_chroot()  install_system_settings()
296  {  {
297   local my_roothdd   local CONFIG
  local grubconf=${INSTALLROOT}/boot/grub/grub.conf  
  local grub2conf=/boot/grub/grub.cfg  
   
  # check for grub2  
  if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]  
  then  
  # needed by grub-mkconfig on the first run  
  if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]  
  then  
  install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die  
  fi  
   
  # set kernelopts  
  if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]  
  then  
  sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  else  
  echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  fi  
  echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die  
   
  # grub-legacy  
  else  
  ### grubconf schreiben  
  source ${INSTALLROOT}/boot/kernelversion  
   
  #for alx only  
  if [ -e ${INSTALLROOT}/etc/alx_version ]  
  then  
  OLD_ALXVER="${ALXVER}"  
  source ${INSTALLROOT}/etc/alx_version  
  KRNVER="ALX-${ALXVER}"  
  ALXVER="${OLD_ALXVER}"  
  fi  
   
  [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  
  [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  
  [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"  
298    
299   # uuid support   # write fstab
300   if is_uuid_supported   CONFIG="${INSTALLROOT}/etc/fstab"
301   then   clearconfig
302   my_roothdd="UUID=$(get_uuid ${ROOTHDD})"   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
303   else   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
304   my_roothdd="${ROOTHDD}"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
  fi  
305    
306   : > ${grubconf} || dialog_die   # install network config skeleton
307   echo "default 0" >> ${grubconf} || dialog_die   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
308   echo "timeout 3" >> ${grubconf} || dialog_die   clearconfig
309   # using current root password   addconfig 'ONBOOT="yes"'
310   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die   addconfig 'NETWORKING="dhcp"'
311    
312   echo  >> ${grubconf} || dialog_die   # intel framebuffer quirk
313   echo "# normal boot" >> ${grubconf} || dialog_die   CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
314   echo "title ${KRNVER}" >> ${grubconf} || dialog_die   if [ -e ${CONFIG} ] && [ -e /proc/fb ]
315   echo "root (hd0,0)" >> ${grubconf} || dialog_die   then
316   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
  if is_initrd_supported  
317   then   then
318   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
319     [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
320   fi   fi
321     fi
322    }
323    
  echo >> ${grubconf} || dialog_die  
  echo "# admin boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die  
  echo "lock"  >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
324    
325   echo >> ${grubconf} || dialog_die  ### installer dialogs ###
  echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die  
  echo "lock"  >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
326    
327   # bootsector schreiben chrooted schreiben (lfs/magellan)  dialog_die()
328   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  {
329  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null   ERROR="$1"
330  root (hd0,0)   RETVAL="$?"
331  setup (hd0)   dialog_install_failure
332  quit   exit 1
333  EOF  }
 exit 0  
 CHROOTEOF  
  fi  
334    
335   ## enter chroot  dialog_warning()
336   mount -t proc proc ${INSTALLROOT}/proc  {
337   mount -t sysfs sysfs ${INSTALLROOT}/sys   local retval
  mount -o bind /dev ${INSTALLROOT}/dev  
  chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLROOT}/proc  
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
  rm ${INSTALLROOT}/root/.installrc  
 }  
   
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
   
 install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
338    
339   if [[ ${FORMFACTOR} = laptop ]]   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
340     retval=$?
341     if [[ ${retval} -eq 1 ]]
342   then   then
343   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   clear
344     echo $"The process was aborted."
345     exit 1
346   fi   fi
347    }
348    
  # install an appropriate uvesafb.conf  
  install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die  
  echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die  
   
  # install an appropriate viafb.conf  
  echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die  
   
  # install an appropriate i810fb.conf  
  echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die  
   
  cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  
 echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  
 mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  
 exit 0  
 CHROOTEOF  
349    
350   ## enters chroot  ### installer tasks ###
  mount -t proc proc ${INSTALLROOT}/proc  
  mount -t sysfs sysfs ${INSTALLROOT}/sys  
  mount -o bind /dev ${INSTALLROOT}/dev  
  chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLROOT}/proc  
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
  rm ${INSTALLROOT}/root/.installrc  
 }  
351    
352  is_uuid_supported()  task_setup_system_menu()
353  {  {
354   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   local mode
355     local retval
356    
357     mode="$(dialog_setup_system_menu)"
358     retval=$?
359     [[ ${retval} -eq 1 ]] && return 1
360     if [[ ${retval} -eq 0 ]]
361   then   then
362   # only detect uuids if supported   case "${mode}" in
363   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   "1") run_install_auto ;;
364   then   "2") run_install_normal ;;
365   return 0   "") task_setup_system_menu;;
366   fi   esac
367   fi   fi
   
  return 1  
368  }  }
369    
370  get_uuid()  task_hardware_detection()
371  {  {
372   local UUID   local message
  local SEC_TYPE  
  local TYPE  
373    
374   local dev="$1"   run_hardware_detection_disks
375   [[ -z ${dev} ]] && dialog_die "no dev given"  
376     message+=$"Harddrives:\n"
377    
378   # check if given device is already an UUID   if [[ ! -z ${ALL_DISKS} ]]
  if [[ ${dev/UUID=/}x != ${dev}x ]]  
379   then   then
380   eval "${dev}"   for i in ${ALL_DISKS}
381   else   do
382   eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')   message+="\Z3${i}\Zn "
383     done
384     message+="\n"
385   fi   fi
  echo "${UUID}"  
 }  
386    
387  install_system_settings()   if [[ ! -z ${ALL_CDROMS} ]]
 {  
  # schreibe fstab  
  if is_uuid_supported  
388   then   then
389   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die   message+="\n"
390   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   message+=$"Optical disk drives:\n"
391   else   for i in ${ALL_CDROMS}
392   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die   do
393   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   message+="\Z3${i}\Zn"
394     done
395     message+="\n"
396   fi   fi
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
397    
398   # install network config skeleton   # other devices
399   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die   run_hardware_detection
400     case "${SPECIALDEVICE}" in
401   # intel framebufer quirk   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
402   if [[ -e /proc/fb ]]   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
403     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
404     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
405     esac
406     if [[ ${FORMFACTOR} = laptop ]]
407   then   then
408   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
  then  
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
409   fi   fi
410    
411     messagebox -y 12 -h $"Detected hardware:" "${message}"
412  }  }
413    
414  install_system_settings_flash()  task_setup_hdd_partitions_manual()
415  {  {
416   # schreibe fstab   local i
417   if is_uuid_supported   local retval
418    
419     if [[ -z ${ALL_DISKS} ]]
420   then   then
421   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die   dialog_no_harddrive_found
422     exit 1
423   else   else
424   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die   HDD=$(dialog_select_target_harddrive)
425     retval=$?
426     [[ ${retval} -eq 1 ]] && return 1
427     if [[ ${retval} -eq 0 ]]
428     then
429     dialog_setup_hdd_info
430     setup_hdd_partitions_manual
431     fi
432   fi   fi
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
433  }  }
434    
435  install_umount_rootfs()  task_setup_hdd_partitions_auto()
436  {  {
437   cd /   local i
438   umount ${INSTALLROOT}/boot || dialog_die   local retval
  umount ${INSTALLROOT} || dialog_die  
  swapoff ${SWAPHDD} || dialog_die  
 }  
439    
440  install_umount_rootfs_flash()   if [[ -z ${ALL_DISKS} ]]
441  {   then
442   cd /   dialog_no_harddrive_found
443   umount ${INSTALLROOT} || dialog_die   exit 1
444     else
445     HDD=$(dialog_select_target_harddrive)
446     retval=$?
447     [[ ${retval} -eq 1 ]] && return 1
448     if [[ ${retval} -eq 0 ]]
449     then
450     dialog_setup_hdd_info_auto
451     dialog_setup_hdd_create_partitions
452     setup_hdd_partitions_auto
453     fi
454     fi
455  }  }
456    
457  install_do_reboot()  task_main()
458  {  {
459   reboot   local method=0
460  }   local retval
461    
462  #################################################   while [[ ${method} -le 2 ]]
463  #     Install Ablauf Scripte #   do
464  #################################################   method=$(dialog_main)
465     retval=$?
466     [[ ${retval} -eq 1 ]] && exit 1
467     if [[ ${retval} -eq 0 ]]
468     then
469     case ${method} in
470     "1") task_setup_system_menu ;;
471     "2") task_hardware_detection ;;
472     "3") install_do_reboot ;;
473     "4") /bin/bash --login -i ;;
474     esac
475     fi
476     done
477    }
478    
479  run_install_normal()  run_install_normal()
480  {  {
481   dialog_hardware_detection   task_hardware_detection
482    
483   dialog_setup_hdd_partitions_manuell   task_setup_hdd_partitions_manual
484   dialog_setup_hdd_format   dialog_setup_hdd_format
485   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
486   install_mount_rootfs   mount_rootfs
487   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
488    
489   dialog_install_settings   dialog_install_settings
490   sleep 1   sleep 1
491   install_system_settings   install_system_settings
492   install_initrd_chroot   if is_initrd_supported
493     then
494   dialog_install_bootsector   dialog_install_initrd
495   install_bootsector_chroot   initrd_config
496     initrd_install
497   install_umount_rootfs   fi
  dialog_install_successful  
 }  
   
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
498    
499   dialog_install_bootsector   dialog_install_bootsector
500   install_bootsector_chroot   bootloader_config
501     bootloader_install
502    
503   install_umount_rootfs_flash   umount_rootfs
504   dialog_install_successful   dialog_install_successful
505  }  }
506    
507  run_install_auto()  run_install_auto()
508  {  {
509   dialog_hardware_detection   task_hardware_detection
510    
511   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions_auto
512   dialog_setup_hdd_format   dialog_setup_hdd_format
513   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
514   install_mount_rootfs_flash   mount_rootfs
515   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
516    
517   dialog_install_settings   dialog_install_settings
518   sleep 1   sleep 1
519   install_system_settings_flash   install_system_settings
520   install_initrd_chroot   if is_initrd_supported
521     then
522     dialog_install_initrd
523     initrd_config
524     initrd_install
525     fi
526    
527   dialog_install_bootsector   dialog_install_bootsector
528   install_bootsector_chroot   bootloader_config
529     bootloader_install
530    
531   install_umount_rootfs_flash   umount_rootfs
532   dialog_install_successful   dialog_install_successful
533  }  }
534    
535  dialog_main  # set some proper traps
536    trap "trap_exit" SIGINT SIGQUIT
537    
538    task_main
539    
540  exit 0  exit 0

Legend:
Removed from v.2344  
changed lines
  Added in v.2653